using System;
using System.Collections.Generic;
using System.IO;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using TDCG;
//css_reference Microsoft.DirectX.dll;
//css_reference Microsoft.DirectX.Direct3D.dll;
//css_reference Microsoft.DirectX.Direct3DX.dll;

namespace TDCG.Proportion
{
    public class Type_Mikuko6B_Uni : IProportion
    {
        Dictionary<string, TPONode> nodes;
        public Dictionary<string, TPONode> Nodes { set { nodes = value; }}

        static float DegreeToRadian(float angle)
        {
           return (float)(Math.PI * angle / 180.0);
        }

        public void Execute()
        {
            TPONode node;

            //TX^X̓KpO

            node = nodes["W_Neck"];
            node.RotateX2(DegreeToRadian(9F));

            node = nodes["Me_Left_HighLight_A"];
            node.RotateX(DegreeToRadian(-1F));
            node.RotateY(DegreeToRadian(28F));
            node = nodes["Me_Left_HighLight_B"];
            node.RotateY(DegreeToRadian(-45F));

            node = nodes["W_RightArm"];			//r
            node.RotateZ2(DegreeToRadian(40F));		//ɉ](TX^XAX^X)
            node = nodes["W_LeftArm"];			//r
            node.RotateZ2(DegreeToRadian(-40F));	//ɉ](TX^XAX^X)

            //S̒
            node = nodes["W_Hips"];			//S
            node.RotateX(DegreeToRadian(-3.00F));	//ɋ
            node.Move(0.00F, 0.00F, 1.50F);		//OɈړ(Z^[ʒu)
            node.Scale(0.92F, 0.92F, 0.92F);		//傫

            //
            node = nodes["W_RightShoulder_Dummy"];	//_~[
            node.Scale1(0.895F, 1.00F, 1.00F);		//

            node = nodes["W_RightShoulder"];
            node.Scale1(0.79F, 1.00F, 1.00F);		//

            node = nodes["W_RightArmRoll"];		//r
            node.Scale1(1.21F, 1.00F, 1.00F);		//r𒷂

            node = nodes["W_RightForeArm"];		//r
            node.Scale1(1.00F, 0.79F, 1.00F);		//r𒷂A㉺ɔ

            node = nodes["W_RightForeArmRoll"];		//Ђ
            node.Scale1(1.21F, 0.79F, 1.00F);		//r𒷂A㉺ɔ

            node = nodes["W_RightHand"];		//
            node.Scale(0.895F, 0.895F, 0.895F);		//

            node = nodes["W_LeftShoulder_Dummy"];	//_~[
            node.Scale1(0.895F, 1.00F, 1.00F);		//

            node = nodes["W_LeftShoulder"];
            node.Scale1(0.79F, 1.00F, 1.00F);		//

            node = nodes["W_LeftArmRoll"];		//r
            node.Scale1(1.21F, 1.00F, 1.00F);		//r𒷂

            node = nodes["W_LeftForeArm"];		//r
            node.Scale1(1.00F, 0.79F, 1.00F);		//r𒷂A㉺ɔ

            node = nodes["W_LeftForeArmRoll"];		//Ђ
            node.Scale1(1.21F, 0.79F, 1.00F);		//r𒷂A㉺ɔ

            node = nodes["W_LeftHand"];			//
            node.Scale(0.895F, 0.895F, 0.895F);		//

            //
            node = nodes["W_LeftHips_Dummy"];		//_~[
            node.RotateX(DegreeToRadian(2.00F));	//ɉ]
            node.Move(0.10F, -0.20F, -0.10F);		//Ҋ֐߂OAAɈړ

            node = nodes["W_LeftUpLegRoll"];		//(ʒu)
            node.Scale1(0.895F, 1.00F, 0.895F);		//ڂׂ̉
            node.Move(0.10F, 0.00F, 0.00F);		//OɈړ

            node = nodes["W_LeftLeg"];			//Ђ
            node.Scale1(1.00F, 1.21F, 1.00F);		//()𒷂
            node.RotateZ(DegreeToRadian(-1.00F));	//ɉ](Xr܂)

            node = nodes["W_LeftLegRoll"];		//Ђ(ʒu)
            node.Scale1(1.00F, 1.42F, 1.00F);		//()𒷂

            node = nodes["W_LeftFoot"];			//
            node.Scale(0.895F, 0.895F, 0.895F);		//
            node.RotateX(DegreeToRadian(6.00F));	//ɉ]
            node.RotateZ(DegreeToRadian(1.00F));	//Oɉ](Ђ̑łp)

            node = nodes["W_RightHips_Dummy"];		//_~[
            node.RotateX(DegreeToRadian(2.00F));	//ɉ]
            node.Move(-0.10F, -0.20F, -0.10F);		//Ҋ֐߂OAAɈړ

            node = nodes["W_RightUpLegRoll"];		//(ʒu)
            node.Scale1(0.895F, 1.00F, 0.895F);		//ڂׂ̉
            node.Move(-0.10F, 0.00F, 0.00F);		//OɈړ

            node = nodes["W_RightLeg"];			//Ђ
            node.Scale1(1.00F, 1.21F, 1.00F);		//()𒷂
            node.RotateZ(DegreeToRadian(1.00F));	//ɉ](Xr܂)

            node = nodes["W_RightLegRoll"];		//Ђ(ʒu)
            node.Scale1(1.00F, 1.42F, 1.00F);		//()𒷂

            node = nodes["W_RightFoot"];		//
            node.Scale(0.895F, 0.895F, 0.895F);		//
            node.RotateX(DegreeToRadian(6.00F));	//ɉ]
            node.RotateZ(DegreeToRadian(-1.00F));	//Oɉ](Ђ̑łp)

            //̊
            node = nodes["face_oya"];
            node.Move(0.00F, -0.10F, 0.00F);		//Z

            node = nodes["W_Neck"];
            node.RotateX2(DegreeToRadian(-9F));		//ɉ]

            node = nodes["W_Spine_Dummy"];
            node.Move(0.00F, 0.00F, -0.10F);		//Oɔ

            node = nodes["W_Spine1"];
            node.Scale1(0.895F, 1.00F, 1.00F);		//㔼g̉

            node = nodes["W_Spine2"];
            node.Scale1(0.895F, 1.00F, 1.00F);		//㔼g2̉

            node = nodes["W_Spine3"];
            node.Scale1(0.895F, 1.00F, 1.00F);		//㔼g3̉

            //ڃnCCg
            node = nodes["Me_Left_HighLight_A"];
            node.Move(-0.25F, -0.10F, 0.08F);

            node = nodes["Me_Left_HighLight_B"];
            node.Scale(1.50F, 1.50F, 1.50F);
            node.Move(0.10F, 0.02F, 0.00F);

            node = nodes["Me_Left_RighLight_A"];
            node.RotateX(DegreeToRadian(-1.00F));
            node.Move(0.00F, -0.10F, 0.00F);

            node = nodes["Me_Left_RighLight_B"];
            node.Scale(1.50F, 1.50F, 1.50F);
            node.Move(-0.15F, 0.02F, 0.00F);

            //@Chichi_Up3_Uni:100%Ɠl
            node = nodes["Chichi_Right1"];
            node.Scale(1.05F, 0.90F, 0.95F);
            node.RotateX(DegreeToRadian(-7.11F));
            node.RotateY(DegreeToRadian(-2.52F));
            node.RotateZ(DegreeToRadian(-0.39F));

            node = nodes["Chichi_Right2"];
            node.Scale(1.07F, 1.25F, 1.18F);

            node = nodes["Chichi_Right3"];
            node.Scale(0.89F, 0.89F, 0.89F);

            node = nodes["Chichi_Left1"];
            node.Scale(1.05F, 0.90F, 0.95F);
            node.RotateX(DegreeToRadian(-7.11F));
            node.RotateY(DegreeToRadian(2.52F));
            node.RotateZ(DegreeToRadian(-0.39F));

            node = nodes["Chichi_Left2"];
            node.Scale(1.07F, 1.25F, 1.18F);

            node = nodes["Chichi_Left3"];
            node.Scale(0.89F, 0.89F, 0.89F);
        }
    }
}
